# -*- coding: utf-8 -*-

"""
    songkiss

    This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
"""

from .base_controller import BaseController
from ..api_helper import APIHelper
from ..configuration import Configuration
from ..http.auth.custom_query_auth import CustomQueryAuth
from ..models.get_search_artists_response import GETSearchArtistsResponse

class SearchController(BaseController):

    """A Controller to access Endpoints in the songkiss API."""


    def get_search_artists(self,
                           query=None,
                           page=None,
                           per_page=None):
        """Does a GET request to /search/artists.json.

        Search artists by name

        Args:
            query (string, optional): TODO: type description here. Example: 
            page (int, optional): This is how it works.
            per_page (int, optional): TODO: type description here. Example: 

        Returns:
            GETSearchArtistsResponse: Response from the API. List of found
                artists

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        # Prepare query URL
        _query_builder = Configuration.base_uri
        _query_builder += '/search/artists.json'
        _query_parameters = {
            'query': query,
            'page': page,
            'per_page': per_page
        }
        _query_builder = APIHelper.append_url_with_query_parameters(_query_builder,
            _query_parameters, Configuration.array_serialization)
        _query_url = APIHelper.clean_url(_query_builder)

        # Prepare headers
        _headers = {
            'accept': 'application/json'
        }

        # Prepare and execute request
        _request = self.http_client.get(_query_url, headers=_headers)
        CustomQueryAuth.apply(_request)
        _context = self.execute_request(_request)
        self.validate_response(_context)

        # Return appropriate type
        return APIHelper.json_deserialize(_context.response.raw_body, GETSearchArtistsResponse.from_dictionary)
